commit 7bbfc84f0b5118f8a6ba9a2cc6e97a1461e2539c
Author: Leszek Koltunski <leszek@koltunski.pl>
Date:   Mon Oct 18 23:43:23 2021 +0200

    Progress with serializing object to JSON: rotations.

diff --git a/src/main/java/org/distorted/objectlib/main/TwistyObject.java b/src/main/java/org/distorted/objectlib/main/TwistyObject.java
index 5f597bbb..1df0281c 100644
--- a/src/main/java/org/distorted/objectlib/main/TwistyObject.java
+++ b/src/main/java/org/distorted/objectlib/main/TwistyObject.java
@@ -1380,7 +1380,6 @@ public abstract class TwistyObject extends DistortedNode
   protected abstract float getScreenRatio();
   protected abstract int getNumFaceColors();
   protected abstract int getColor(int face);
-  protected abstract float[][] getCuts(int[] numLayers);
   protected abstract int getNumCubitFaces();
   protected abstract Static4D[] getQuats();
   protected abstract float[][] getCubitPositions(int[] numLayers);
@@ -1403,6 +1402,7 @@ public abstract class TwistyObject extends DistortedNode
   public abstract int[][][] getEnabled();
   public abstract float[] getDist3D(int[] numLayers);
   public abstract ScrambleState[] getScrambleStates();
+  public abstract float[][] getCuts(int[] numLayers);
 
   public abstract Static3D[] getRotationAxis();
   public abstract int[] getBasicAngle();
diff --git a/src/main/java/org/distorted/objectlib/objects/TwistyBandagedAbstract.java b/src/main/java/org/distorted/objectlib/objects/TwistyBandagedAbstract.java
index 00d88acb..2e5cc3eb 100644
--- a/src/main/java/org/distorted/objectlib/objects/TwistyBandagedAbstract.java
+++ b/src/main/java/org/distorted/objectlib/objects/TwistyBandagedAbstract.java
@@ -324,7 +324,7 @@ abstract class TwistyBandagedAbstract extends Twisty6
 
 ///////////////////////////////////////////////////////////////////////////////////////////////////
 
-  protected float[][] getCuts(int[] numLayers)
+  public float[][] getCuts(int[] numLayers)
     {
     int numL = numLayers[0];
 
diff --git a/src/main/java/org/distorted/objectlib/objects/TwistyCuboid.java b/src/main/java/org/distorted/objectlib/objects/TwistyCuboid.java
index 0e9d821e..a934b2ad 100644
--- a/src/main/java/org/distorted/objectlib/objects/TwistyCuboid.java
+++ b/src/main/java/org/distorted/objectlib/objects/TwistyCuboid.java
@@ -533,7 +533,7 @@ public class TwistyCuboid extends Twisty6
 
 ///////////////////////////////////////////////////////////////////////////////////////////////////
 
-  protected float[][] getCuts(int[] numLayers)
+  public float[][] getCuts(int[] numLayers)
     {
     if( mCuts==null )
       {
diff --git a/src/main/java/org/distorted/objectlib/objects/TwistyDiamond.java b/src/main/java/org/distorted/objectlib/objects/TwistyDiamond.java
index 38649aa4..40e93066 100644
--- a/src/main/java/org/distorted/objectlib/objects/TwistyDiamond.java
+++ b/src/main/java/org/distorted/objectlib/objects/TwistyDiamond.java
@@ -164,7 +164,7 @@ public class TwistyDiamond extends Twisty8
 
 ///////////////////////////////////////////////////////////////////////////////////////////////////
 
-  protected float[][] getCuts(int[] numLayers)
+  public float[][] getCuts(int[] numLayers)
     {
     int numL = numLayers[0];
     if( numL<2 ) return null;
diff --git a/src/main/java/org/distorted/objectlib/objects/TwistyDino.java b/src/main/java/org/distorted/objectlib/objects/TwistyDino.java
index 4813caef..eacac38a 100644
--- a/src/main/java/org/distorted/objectlib/objects/TwistyDino.java
+++ b/src/main/java/org/distorted/objectlib/objects/TwistyDino.java
@@ -103,7 +103,7 @@ abstract class TwistyDino extends Twisty6
 
 ///////////////////////////////////////////////////////////////////////////////////////////////////
 
-  protected float[][] getCuts(int[] numLayers)
+  public float[][] getCuts(int[] numLayers)
     {
     if( mCuts==null )
       {
diff --git a/src/main/java/org/distorted/objectlib/objects/TwistyHelicopter.java b/src/main/java/org/distorted/objectlib/objects/TwistyHelicopter.java
index c936fec3..d989a83e 100644
--- a/src/main/java/org/distorted/objectlib/objects/TwistyHelicopter.java
+++ b/src/main/java/org/distorted/objectlib/objects/TwistyHelicopter.java
@@ -173,7 +173,7 @@ public class TwistyHelicopter extends Twisty6
 
 ///////////////////////////////////////////////////////////////////////////////////////////////////
 
-  protected float[][] getCuts(int[] numLayers)
+  public float[][] getCuts(int[] numLayers)
     {
     if( mCuts==null )
       {
diff --git a/src/main/java/org/distorted/objectlib/objects/TwistyIvy.java b/src/main/java/org/distorted/objectlib/objects/TwistyIvy.java
index 43de904a..9e5aa122 100644
--- a/src/main/java/org/distorted/objectlib/objects/TwistyIvy.java
+++ b/src/main/java/org/distorted/objectlib/objects/TwistyIvy.java
@@ -149,7 +149,7 @@ public class TwistyIvy extends Twisty6
 
 ///////////////////////////////////////////////////////////////////////////////////////////////////
 
-  protected float[][] getCuts(int[] numLayers)
+  public float[][] getCuts(int[] numLayers)
     {
     if( mCuts==null )
       {
diff --git a/src/main/java/org/distorted/objectlib/objects/TwistyJing.java b/src/main/java/org/distorted/objectlib/objects/TwistyJing.java
index 9dff2405..cbd92466 100644
--- a/src/main/java/org/distorted/objectlib/objects/TwistyJing.java
+++ b/src/main/java/org/distorted/objectlib/objects/TwistyJing.java
@@ -180,7 +180,7 @@ public class TwistyJing extends Twisty4
 
 ///////////////////////////////////////////////////////////////////////////////////////////////////
 
-  protected float[][] getCuts(int[] numLayers)
+  public float[][] getCuts(int[] numLayers)
     {
     if( mCuts==null )
       {
diff --git a/src/main/java/org/distorted/objectlib/objects/TwistyKilominx.java b/src/main/java/org/distorted/objectlib/objects/TwistyKilominx.java
index 040caa63..ca3895d7 100644
--- a/src/main/java/org/distorted/objectlib/objects/TwistyKilominx.java
+++ b/src/main/java/org/distorted/objectlib/objects/TwistyKilominx.java
@@ -109,7 +109,7 @@ public class TwistyKilominx extends TwistyMinx
 
 ///////////////////////////////////////////////////////////////////////////////////////////////////
 
-  protected float[][] getCuts(int[] numLayers)
+  public float[][] getCuts(int[] numLayers)
     {
     return genericGetCuts(numLayers[0],0.5f);
     }
diff --git a/src/main/java/org/distorted/objectlib/objects/TwistyMegaminx.java b/src/main/java/org/distorted/objectlib/objects/TwistyMegaminx.java
index 3be562f1..67e3a248 100644
--- a/src/main/java/org/distorted/objectlib/objects/TwistyMegaminx.java
+++ b/src/main/java/org/distorted/objectlib/objects/TwistyMegaminx.java
@@ -95,7 +95,7 @@ public class TwistyMegaminx extends TwistyMinx
 
 ///////////////////////////////////////////////////////////////////////////////////////////////////
 
-  protected float[][] getCuts(int[] numLayers)
+  public float[][] getCuts(int[] numLayers)
     {
     return genericGetCuts(numLayers[0],0.5f-MEGA_D);
     }
diff --git a/src/main/java/org/distorted/objectlib/objects/TwistyMirror.java b/src/main/java/org/distorted/objectlib/objects/TwistyMirror.java
index 20665fee..8b4d1b5f 100644
--- a/src/main/java/org/distorted/objectlib/objects/TwistyMirror.java
+++ b/src/main/java/org/distorted/objectlib/objects/TwistyMirror.java
@@ -557,7 +557,7 @@ public class TwistyMirror extends Twisty6
 
 ///////////////////////////////////////////////////////////////////////////////////////////////////
 
-  protected float[][] getCuts(int[] numLayers)
+  public float[][] getCuts(int[] numLayers)
     {
     if( mCuts==null )
       {
diff --git a/src/main/java/org/distorted/objectlib/objects/TwistyPyraminx.java b/src/main/java/org/distorted/objectlib/objects/TwistyPyraminx.java
index d29dc0e8..c80fe9f0 100644
--- a/src/main/java/org/distorted/objectlib/objects/TwistyPyraminx.java
+++ b/src/main/java/org/distorted/objectlib/objects/TwistyPyraminx.java
@@ -235,7 +235,7 @@ public class TwistyPyraminx extends Twisty4
 
 ///////////////////////////////////////////////////////////////////////////////////////////////////
 
-  protected float[][] getCuts(int[] numLayers)
+  public float[][] getCuts(int[] numLayers)
     {
     if( mCuts==null )
       {
diff --git a/src/main/java/org/distorted/objectlib/objects/TwistyRedi.java b/src/main/java/org/distorted/objectlib/objects/TwistyRedi.java
index c56a7c45..efa59532 100644
--- a/src/main/java/org/distorted/objectlib/objects/TwistyRedi.java
+++ b/src/main/java/org/distorted/objectlib/objects/TwistyRedi.java
@@ -152,7 +152,7 @@ public class TwistyRedi extends Twisty6
 
 ///////////////////////////////////////////////////////////////////////////////////////////////////
 
-  protected float[][] getCuts(int[] numLayers)
+  public float[][] getCuts(int[] numLayers)
     {
     if( mCuts==null )
       {
diff --git a/src/main/java/org/distorted/objectlib/objects/TwistyRex.java b/src/main/java/org/distorted/objectlib/objects/TwistyRex.java
index dd95bfb2..562d5c63 100644
--- a/src/main/java/org/distorted/objectlib/objects/TwistyRex.java
+++ b/src/main/java/org/distorted/objectlib/objects/TwistyRex.java
@@ -147,7 +147,7 @@ public class TwistyRex extends Twisty6
 
 ///////////////////////////////////////////////////////////////////////////////////////////////////
 
-  protected float[][] getCuts(int[] numLayers)
+  public float[][] getCuts(int[] numLayers)
     {
     if( mCuts==null )
       {
diff --git a/src/main/java/org/distorted/objectlib/objects/TwistySkewb.java b/src/main/java/org/distorted/objectlib/objects/TwistySkewb.java
index def988dd..d3649ba0 100644
--- a/src/main/java/org/distorted/objectlib/objects/TwistySkewb.java
+++ b/src/main/java/org/distorted/objectlib/objects/TwistySkewb.java
@@ -175,7 +175,7 @@ public class TwistySkewb extends Twisty6
 
 ///////////////////////////////////////////////////////////////////////////////////////////////////
 
-  protected float[][] getCuts(int[] numLayers)
+  public float[][] getCuts(int[] numLayers)
     {
     if( mCuts==null )
       {
diff --git a/src/main/java/org/distorted/objectlib/objects/TwistySquare.java b/src/main/java/org/distorted/objectlib/objects/TwistySquare.java
index 58cdd088..cd8bb015 100644
--- a/src/main/java/org/distorted/objectlib/objects/TwistySquare.java
+++ b/src/main/java/org/distorted/objectlib/objects/TwistySquare.java
@@ -120,7 +120,7 @@ abstract class TwistySquare extends Twisty6
 
 ///////////////////////////////////////////////////////////////////////////////////////////////////
 
-  protected float[][] getCuts(int[] numLayers)
+  public float[][] getCuts(int[] numLayers)
     {
     if( mCuts==null )
       {
diff --git a/src/main/java/org/distorted/objectlib/objects/TwistyUltimate.java b/src/main/java/org/distorted/objectlib/objects/TwistyUltimate.java
index b6b9eaee..e7585c9e 100644
--- a/src/main/java/org/distorted/objectlib/objects/TwistyUltimate.java
+++ b/src/main/java/org/distorted/objectlib/objects/TwistyUltimate.java
@@ -374,7 +374,7 @@ public class TwistyUltimate extends Twisty12
 
 ///////////////////////////////////////////////////////////////////////////////////////////////////
 
-  protected float[][] getCuts(int[] numLayers)
+  public float[][] getCuts(int[] numLayers)
     {
     if( mCuts==null )
       {