commit 8b3b1d85e18906e82e57afe381f240d834456cbd
Author: Leszek Koltunski <leszek@koltunski.pl>
Date:   Tue Dec 20 14:59:19 2022 +0100

    Changes to the initialization - initialize the 'bought objects'

diff --git a/src/main/java/org/distorted/objectlib/json/JsonReader.java b/src/main/java/org/distorted/objectlib/json/JsonReader.java
index 79f2b470..62a2ac8b 100644
--- a/src/main/java/org/distorted/objectlib/json/JsonReader.java
+++ b/src/main/java/org/distorted/objectlib/json/JsonReader.java
@@ -66,7 +66,7 @@ public class JsonReader
   private int[] mNumLayers;
   private float mSize;
   private int mScrambleType, mNumScrambles;
-  private boolean mIsFree;
+  private int mPrice;
   private int[] mColor;
   private int mInternalColor;
   private boolean mResetMaps;
@@ -107,7 +107,7 @@ public class JsonReader
     mNumScrambles    = object.getInt("scrambles");
     mResetMaps       = object.getBoolean("resetmaps");
     mNumFaces        = object.getInt("num_faces");
-    mIsFree          = true;
+    mPrice           = 0;
 
     try
       {
@@ -136,7 +136,7 @@ public class JsonReader
     mNumScrambles    = object.getInt("scrambles");
     mResetMaps       = object.getBoolean("resetmaps");
     mNumFaces        = object.getInt("num_faces");
-    mIsFree          = true;
+    mPrice           = 0;
 
     try
       {
@@ -193,7 +193,10 @@ public class JsonReader
       mSignature = new ObjectSignature(signature);
       }
 
-    mIsFree = object.optBoolean("free", true);
+    boolean free = object.optBoolean("free", true);
+
+    if( free ) mPrice = 0;
+    else mPrice = object.optInt("price", ObjectType.DEFAULT_PRICE_OF_OLD_OBJECTS );
     }
 
 ///////////////////////////////////////////////////////////////////////////////////////////////////
@@ -843,7 +846,7 @@ public class JsonReader
 
 ///////////////////////////////////////////////////////////////////////////////////////////////////
 
-  public void readNumScramblesAndIsFree(Context context, String fileName) throws IOException, JSONException
+  public void readNumScramblesAndPrice(Context context, String fileName) throws IOException, JSONException
     {
     File file = new File(context.getFilesDir(), fileName);
     InputStream stream = new FileInputStream(file);
@@ -858,7 +861,10 @@ public class JsonReader
     JSONObject object = new JSONObject(contents.toString());
     JSONObject metadata = object.getJSONObject("metadata");
     mNumScrambles = metadata.getInt("scrambles");
-    mIsFree       = metadata.optBoolean("free",true);
+
+    boolean free = metadata.optBoolean("free",true);
+    if( free ) mPrice = 0;
+    else mPrice = metadata.optInt("price", ObjectType.DEFAULT_PRICE_OF_OLD_OBJECTS );
     }
 
 ///////////////////////////////////////////////////////////////////////////////////////////////////
@@ -1057,9 +1063,9 @@ public class JsonReader
 
 ///////////////////////////////////////////////////////////////////////////////////////////////////
 
-  public boolean isFree()
+  public int getPrice()
     {
-    return mIsFree;
+    return mPrice;
     }
 
 ///////////////////////////////////////////////////////////////////////////////////////////////////
diff --git a/src/main/java/org/distorted/objectlib/json/JsonWriter.java b/src/main/java/org/distorted/objectlib/json/JsonWriter.java
index 9ea7fe3f..c1058ae7 100644
--- a/src/main/java/org/distorted/objectlib/json/JsonWriter.java
+++ b/src/main/java/org/distorted/objectlib/json/JsonWriter.java
@@ -386,7 +386,7 @@ public class JsonWriter
 
 ///////////////////////////////////////////////////////////////////////////////////////////////////
 
-  private JSONObject generateMetadata(TwistyObject object, int numScramble, boolean isFree) throws JSONException
+  private JSONObject generateMetadata(TwistyObject object, int numScramble, int price) throws JSONException
     {
     JSONObject metadata = new JSONObject();
 
@@ -399,7 +399,7 @@ public class JsonWriter
     metadata.put("shortname"  , object.getShortName() );
     metadata.put("resetmaps"  , object.shouldResetTextureMaps() );
     metadata.put("num_faces"  , object.getNumFaces() );
-    metadata.put("free"       , isFree );
+    metadata.put("price"      , price );
 
     JSONArray sigArray = new JSONArray();
     long[] sig = object.getSignature().getArray();
@@ -591,11 +591,11 @@ public class JsonWriter
 
 ///////////////////////////////////////////////////////////////////////////////////////////////////
 
-  public String createObjectString(TwistyObject object,int numScramble, boolean isFree) throws JSONException
+  public String createObjectString(TwistyObject object,int numScramble, int price) throws JSONException
     {
     JSONObject json = new JSONObject();
 
-    JSONObject metadata    = generateMetadata(object,numScramble,isFree);
+    JSONObject metadata    = generateMetadata(object,numScramble,price);
     JSONObject mesh        = generateMesh(object);
     JSONArray  axis        = generateAxis(object);
     JSONArray  quats       = generateQuats(object);
diff --git a/src/main/java/org/distorted/objectlib/main/ObjectType.java b/src/main/java/org/distorted/objectlib/main/ObjectType.java
index daf67ffa..8ed1660b 100644
--- a/src/main/java/org/distorted/objectlib/main/ObjectType.java
+++ b/src/main/java/org/distorted/objectlib/main/ObjectType.java
@@ -23,85 +23,86 @@ import org.distorted.objectlib.objects.*;
 
 public enum ObjectType
   {
-  CUBE_2 ( TwistyCuboid.class        , 12, R.drawable.cube_2, true, true,  new InitData(new int[] {2,2,2})),
-  CUBE_3 ( TwistyCuboid.class        , 17, R.drawable.cube_3, true, true,  new InitData(new int[] {3,3,3})),
-  CUBE_4 ( TwistyCuboid.class        , 24, R.drawable.cube_4, true, false, new InitData(new int[] {4,4,4})),
-  CUBE_5 ( TwistyCuboid.class        , 28, R.drawable.cube_5, true, false, new InitData(new int[] {5,5,5})),
-  CUBE_6 ( TwistyCuboid.class        , 35, R.drawable.cube_6, true, false, new InitData(new int[] {6,6,6})),
-
-  CUBE_7 ( TwistyCuboid.class        , 42, R.drawable.cube_7, true, false, new InitData(new int[] {7,7,7})),
-  BAN1_3 ( TwistyBandagedCuboid.class, 16, R.drawable.ban1_3, true, true,  new InitData(new int[] {3,3,3}, TwistyBandagedCuboid.POS_1)),
-  BAN2_3 ( TwistyBandagedCuboid.class, 20, R.drawable.ban2_3, true, false, new InitData(new int[] {3,3,3}, TwistyBandagedCuboid.POS_2)),
-  BAN3_3 ( TwistyBandagedCuboid.class, 16, R.drawable.ban3_3, true, false, new InitData(new int[] {3,3,3}, TwistyBandagedCuboid.POS_3)),
-  BAN4_3 ( TwistyBandagedCuboid.class, 22, R.drawable.ban4_3, true, false, new InitData(new int[] {3,3,3}, TwistyBandagedCuboid.POS_4)),
-
-  CU_323 ( TwistyCuboid.class        , 15, R.drawable.cu_323, true, false, new InitData(new int[] {3,2,3})),
-  CU_232 ( TwistyCuboid.class        , 16, R.drawable.cu_232, true, true,  new InitData(new int[] {2,3,2})),
-  CU_343 ( TwistyCuboid.class        , 23, R.drawable.cu_343, true, false, new InitData(new int[] {3,4,3})),
-  SQU1_3 ( TwistySquare1.class       , 24, R.drawable.squ1_3, true, false, new InitData(new int[] {3,2,3})),
-  SQU2_3 ( TwistySquare2.class       , 24, R.drawable.squ2_3, true, false, new InitData(new int[] {3,2,3})),
-
-  MORP_2 ( TwistyMorphix.class       , 12, R.drawable.morp_2, true, true,  new InitData(new int[] {2,2,2})),
-  JING_2 ( TwistyJing.class          , 11, R.drawable.jing_2, true, false, new InitData(new int[] {2,2,2,2})),
-  PYRA_3 ( TwistyPyraminx.class      , 10, R.drawable.pyra_3, true, true,  new InitData(new int[] {3,3,3,3})),
-  PYRA_4 ( TwistyPyraminx.class      , 17, R.drawable.pyra_4, true, false, new InitData(new int[] {4,4,4,4})),
-  PYRA_5 ( TwistyPyraminx.class      , 23, R.drawable.pyra_5, true, false, new InitData(new int[] {5,5,5,5})),
-
-  TRAJ_3 ( TwistyTrajber.class       , 17, R.drawable.traj_3, true, false, new InitData(new int[] {3,3,3})),
-  TRAJ_4 ( TwistyTrajber.class       , 24, R.drawable.traj_4, true, false, new InitData(new int[] {4,4,4})),
-  DIAM_2 ( TwistyDiamond.class       , 12, R.drawable.diam_2, true, true,  new InitData(new int[] {2,2,2,2})),
-  DIAM_3 ( TwistyDiamond.class       , 24, R.drawable.diam_3, true, false, new InitData(new int[] {3,3,3,3})),
-  DIAM_4 ( TwistyDiamond.class       , 32, R.drawable.diam_4, true, false, new InitData(new int[] {4,4,4,4})),
-
-  ULTI_2 ( TwistyUltimate.class      , 18, R.drawable.ulti_2, true, false, new InitData(new int[] {2,2,2,2})),
-  KILO_3 ( TwistyKilominx.class      , 18, R.drawable.kilo_3, true, false, new InitData(new int[] {3,3,3,3,3,3})),
-  MEGA_3 ( TwistyMegaminx.class      , 21, R.drawable.mega_3, true, true,  new InitData(new int[] {3,3,3,3,3,3})),
-  KILO_5 ( TwistyKilominx.class      , 33, R.drawable.kilo_5, true, false, new InitData(new int[] {5,5,5,5,5,5})),
-  MEGA_5 ( TwistyMegaminx.class      , 37, R.drawable.mega_5, true, false, new InitData(new int[] {5,5,5,5,5,5})),
-
-  CRYS_3 ( TwistyCrystal.class       , 27, R.drawable.crys_3, true, false, new InitData(new int[] {3,3,3,3,3,3})),
-  STAR_3 ( TwistyStarminx.class      , 27, R.drawable.star_3, true, false, new InitData(new int[] {3,3,3,3,3,3})),
-  PENT_2 ( TwistyPentultimate.class  , 21, R.drawable.pent_2, true, false, new InitData(new int[] {2,2,2,2,2,2})),
-  DINO_3 ( TwistyDino6.class         , 10, R.drawable.dino_3, true, true , new InitData(new int[] {3,3,3,3})),
-  DIN4_3 ( TwistyDino4.class         ,  9, R.drawable.din4_3, true, false, new InitData(new int[] {3,3,3,3})),
-
-  MIRR_2 ( TwistyMirror.class        , 12, R.drawable.mirr_2, true, true,  new InitData(new int[] {2,2,2})),
-  MIRR_3 ( TwistyMirror.class        , 17, R.drawable.mirr_3, true, false, new InitData(new int[] {3,3,3})),
-  MIRR_4 ( TwistyMirror.class        , 24, R.drawable.mirr_4, true, false, new InitData(new int[] {4,4,4})),
-  IVY_2  ( TwistyIvy.class           ,  9, R.drawable.ivy_2 , true, true,  new InitData(new int[] {2,2,2,2})),
-  REX_3  ( TwistyRex.class           , 19, R.drawable.rex_3 , true, false, new InitData(new int[] {3,3,3,3})),
-
-  REDI_3 ( TwistyRedi.class          , 16, R.drawable.redi_3, true, true,  new InitData(new int[] {3,3,3,3})),
-  HELI_3 ( TwistyHelicopter.class    , 20, R.drawable.heli_3, true, false, new InitData(new int[] {3,3,3,3,3,3})),
-  SKEW_2 ( TwistySkewb.class         , 11, R.drawable.skew_2, true, true,  new InitData(new int[] {2,2,2,2})),
-  SKEW_3 ( TwistySkewb.class         , 21, R.drawable.skew_3, true, false, new InitData(new int[] {3,3,3,3})),
-  CONT_2 ( TwistyContainer.class     , 12, R.drawable.cont_2, true, false, new InitData(new int[] {2,2,2,2})),
-
-  FISH_3 ( TwistyFisher.class        , 24, R.drawable.fish_3, true, false, new InitData(new int[] {3,3,3})),
-  WIND_3 ( TwistyWindmill.class      , 24, R.drawable.wind_3, true, false, new InitData(new int[] {3,3,3})),
-  AXIS_3 ( TwistyAxis.class          , 24, R.drawable.axis_3, true, false, new InitData(new int[] {3,3,3})),
-  VOID_3 ( TwistyVoid.class          , 17, R.drawable.void_3, true, false, new InitData(new int[] {3,3,3})),
-  MIXU_3 ( TwistyMixup3x3.class      , 24, R.drawable.mixu_3, true, false, new InitData(new int[] {3,3,3})),
-
-  MIXP_3 ( TwistyMixup3x3Plus.class  , 28, R.drawable.mixp_3, true , false, new InitData(new int[] {3,3,3})),
-  PDUO_2 ( TwistyPyraminxDuo.class   ,  4, R.drawable.pduo_2, false, false, new InitData(new int[] {2,2,2,2})),
-  MORP_3 ( TwistyMorphix.class       , 17, R.drawable.morp_3, false, false, new InitData(new int[] {3,3,3})),
-  MORP_4 ( TwistyMorphix.class       , 24, R.drawable.morp_4, false, false, new InitData(new int[] {4,4,4})),
-  BALL_4 ( TwistyMasterball.class    , 28, R.drawable.ball_4, false, false, new InitData(new int[] {4,2,2,2,2})),
-
-  CRA1_2 ( TwistyCrazy2x2.class      , 16, R.drawable.cra1_2, false, false, new InitData(new int[] {2,2,2})),
-  CRA1_3 ( TwistyCrazy3x3.class      , 22, R.drawable.cra1_3, false, false, new InitData(new int[] {3,3,3}, TwistyCrazy3x3.CRAZY  )),
-  CRA2_3 ( TwistyCrazy3x3.class      , 22, R.drawable.cra2_3, false, false, new InitData(new int[] {3,3,3}, TwistyCrazy3x3.MERCURY)),
-  CRA3_3 ( TwistyCrazy3x3.class      , 22, R.drawable.cra3_3, false, false, new InitData(new int[] {3,3,3}, TwistyCrazy3x3.VENUS  )),
-  CRA4_3 ( TwistyCrazy3x3.class      , 22, R.drawable.cra4_3, false, false, new InitData(new int[] {3,3,3}, TwistyCrazy3x3.EARTH  )),
-  CRA5_3 ( TwistyCrazy3x3.class      , 22, R.drawable.cra5_3, false, false, new InitData(new int[] {3,3,3}, TwistyCrazy3x3.MARS   )),
-  CRA6_3 ( TwistyCrazy3x3.class      , 22, R.drawable.cra6_3, false, false, new InitData(new int[] {3,3,3}, TwistyCrazy3x3.JUPITER)),
-  CRA7_3 ( TwistyCrazy3x3.class      , 22, R.drawable.cra7_3, false, false, new InitData(new int[] {3,3,3}, TwistyCrazy3x3.SATURN )),
-  CRA8_3 ( TwistyCrazy3x3.class      , 22, R.drawable.cra8_3, false, false, new InitData(new int[] {3,3,3}, TwistyCrazy3x3.URANUS )),
-  CRA9_3 ( TwistyCrazy3x3.class      , 22, R.drawable.cra9_3, false, false, new InitData(new int[] {3,3,3}, TwistyCrazy3x3.NEPTUNE)),
+  CUBE_2 ( TwistyCuboid.class        , 12, R.drawable.cube_2, true,     0, new InitData(new int[] {2,2,2})),
+  CUBE_3 ( TwistyCuboid.class        , 17, R.drawable.cube_3, true,     0, new InitData(new int[] {3,3,3})),
+  CUBE_4 ( TwistyCuboid.class        , 24, R.drawable.cube_4, true,    50, new InitData(new int[] {4,4,4})),
+  CUBE_5 ( TwistyCuboid.class        , 28, R.drawable.cube_5, true,    60, new InitData(new int[] {5,5,5})),
+  CUBE_6 ( TwistyCuboid.class        , 35, R.drawable.cube_6, true,    70, new InitData(new int[] {6,6,6})),
+
+  CUBE_7 ( TwistyCuboid.class        , 42, R.drawable.cube_7, true,   100, new InitData(new int[] {7,7,7})),
+  BAN1_3 ( TwistyBandagedCuboid.class, 16, R.drawable.ban1_3, true,     0, new InitData(new int[] {3,3,3}, TwistyBandagedCuboid.POS_1)),
+  BAN2_3 ( TwistyBandagedCuboid.class, 20, R.drawable.ban2_3, true,    50, new InitData(new int[] {3,3,3}, TwistyBandagedCuboid.POS_2)),
+  BAN3_3 ( TwistyBandagedCuboid.class, 16, R.drawable.ban3_3, true,    50, new InitData(new int[] {3,3,3}, TwistyBandagedCuboid.POS_3)),
+  BAN4_3 ( TwistyBandagedCuboid.class, 22, R.drawable.ban4_3, true,    60, new InitData(new int[] {3,3,3}, TwistyBandagedCuboid.POS_4)),
+
+  CU_323 ( TwistyCuboid.class        , 15, R.drawable.cu_323, true,    40, new InitData(new int[] {3,2,3})),
+  CU_232 ( TwistyCuboid.class        , 16, R.drawable.cu_232, true,     0, new InitData(new int[] {2,3,2})),
+  CU_343 ( TwistyCuboid.class        , 23, R.drawable.cu_343, true,    50, new InitData(new int[] {3,4,3})),
+  SQU1_3 ( TwistySquare1.class       , 24, R.drawable.squ1_3, true,    70, new InitData(new int[] {3,2,3})),
+  SQU2_3 ( TwistySquare2.class       , 24, R.drawable.squ2_3, true,    70, new InitData(new int[] {3,2,3})),
+
+  MORP_2 ( TwistyMorphix.class       , 12, R.drawable.morp_2, true,     0, new InitData(new int[] {2,2,2})),
+  JING_2 ( TwistyJing.class          , 11, R.drawable.jing_2, true,    50, new InitData(new int[] {2,2,2,2})),
+  PYRA_3 ( TwistyPyraminx.class      , 10, R.drawable.pyra_3, true,     0, new InitData(new int[] {3,3,3,3})),
+  PYRA_4 ( TwistyPyraminx.class      , 17, R.drawable.pyra_4, true,    50, new InitData(new int[] {4,4,4,4})),
+  PYRA_5 ( TwistyPyraminx.class      , 23, R.drawable.pyra_5, true,    70, new InitData(new int[] {5,5,5,5})),
+
+  TRAJ_3 ( TwistyTrajber.class       , 17, R.drawable.traj_3, true,    50, new InitData(new int[] {3,3,3})),
+  TRAJ_4 ( TwistyTrajber.class       , 24, R.drawable.traj_4, true,    60, new InitData(new int[] {4,4,4})),
+  DIAM_2 ( TwistyDiamond.class       , 12, R.drawable.diam_2, true,     0, new InitData(new int[] {2,2,2,2})),
+  DIAM_3 ( TwistyDiamond.class       , 24, R.drawable.diam_3, true,    60, new InitData(new int[] {3,3,3,3})),
+  DIAM_4 ( TwistyDiamond.class       , 32, R.drawable.diam_4, true,    80, new InitData(new int[] {4,4,4,4})),
+
+  ULTI_2 ( TwistyUltimate.class      , 18, R.drawable.ulti_2, true,    75, new InitData(new int[] {2,2,2,2})),
+  KILO_3 ( TwistyKilominx.class      , 18, R.drawable.kilo_3, true,    50, new InitData(new int[] {3,3,3,3,3,3})),
+  MEGA_3 ( TwistyMegaminx.class      , 21, R.drawable.mega_3, true,     0, new InitData(new int[] {3,3,3,3,3,3})),
+  KILO_5 ( TwistyKilominx.class      , 33, R.drawable.kilo_5, true,    80, new InitData(new int[] {5,5,5,5,5,5})),
+  MEGA_5 ( TwistyMegaminx.class      , 37, R.drawable.mega_5, true,   100, new InitData(new int[] {5,5,5,5,5,5})),
+
+  CRYS_3 ( TwistyCrystal.class       , 27, R.drawable.crys_3, true,    70, new InitData(new int[] {3,3,3,3,3,3})),
+  STAR_3 ( TwistyStarminx.class      , 27, R.drawable.star_3, true,    80, new InitData(new int[] {3,3,3,3,3,3})),
+  PENT_2 ( TwistyPentultimate.class  , 21, R.drawable.pent_2, true,    80, new InitData(new int[] {2,2,2,2,2,2})),
+  DINO_3 ( TwistyDino6.class         , 10, R.drawable.dino_3, true,     0, new InitData(new int[] {3,3,3,3})),
+  DIN4_3 ( TwistyDino4.class         ,  9, R.drawable.din4_3, true,    30, new InitData(new int[] {3,3,3,3})),
+
+  MIRR_2 ( TwistyMirror.class        , 12, R.drawable.mirr_2, true,     0, new InitData(new int[] {2,2,2})),
+  MIRR_3 ( TwistyMirror.class        , 17, R.drawable.mirr_3, true,    50, new InitData(new int[] {3,3,3})),
+  MIRR_4 ( TwistyMirror.class        , 24, R.drawable.mirr_4, true,    60, new InitData(new int[] {4,4,4})),
+  IVY_2  ( TwistyIvy.class           ,  9, R.drawable.ivy_2 , true,     0, new InitData(new int[] {2,2,2,2})),
+  REX_3  ( TwistyRex.class           , 19, R.drawable.rex_3 , true,    70, new InitData(new int[] {3,3,3,3})),
+
+  REDI_3 ( TwistyRedi.class          , 16, R.drawable.redi_3, true,     0, new InitData(new int[] {3,3,3,3})),
+  HELI_3 ( TwistyHelicopter.class    , 20, R.drawable.heli_3, true,    80, new InitData(new int[] {3,3,3,3,3,3})),
+  SKEW_2 ( TwistySkewb.class         , 11, R.drawable.skew_2, true,     0, new InitData(new int[] {2,2,2,2})),
+  SKEW_3 ( TwistySkewb.class         , 21, R.drawable.skew_3, true,    70, new InitData(new int[] {3,3,3,3})),
+  CONT_2 ( TwistyContainer.class     , 12, R.drawable.cont_2, true,    40, new InitData(new int[] {2,2,2,2})),
+
+  FISH_3 ( TwistyFisher.class        , 24, R.drawable.fish_3, true,    50, new InitData(new int[] {3,3,3})),
+  WIND_3 ( TwistyWindmill.class      , 24, R.drawable.wind_3, true,    50, new InitData(new int[] {3,3,3})),
+  AXIS_3 ( TwistyAxis.class          , 24, R.drawable.axis_3, true,    60, new InitData(new int[] {3,3,3})),
+  VOID_3 ( TwistyVoid.class          , 17, R.drawable.void_3, true,    70, new InitData(new int[] {3,3,3})),
+  MIXU_3 ( TwistyMixup3x3.class      , 24, R.drawable.mixu_3, true,    70, new InitData(new int[] {3,3,3})),
+
+  MIXP_3 ( TwistyMixup3x3Plus.class  , 28, R.drawable.mixp_3, true ,   70, new InitData(new int[] {3,3,3})),
+  PDUO_2 ( TwistyPyraminxDuo.class   ,  4, R.drawable.pduo_2, false,    0, new InitData(new int[] {2,2,2,2})),
+  MORP_3 ( TwistyMorphix.class       , 17, R.drawable.morp_3, false,   60, new InitData(new int[] {3,3,3})),
+  MORP_4 ( TwistyMorphix.class       , 24, R.drawable.morp_4, false,   70, new InitData(new int[] {4,4,4})),
+  BALL_4 ( TwistyMasterball.class    , 28, R.drawable.ball_4, false,   70, new InitData(new int[] {4,2,2,2,2})),
+
+  CRA1_2 ( TwistyCrazy2x2.class      , 16, R.drawable.cra1_2, false,   50, new InitData(new int[] {2,2,2})),
+  CRA1_3 ( TwistyCrazy3x3.class      , 22, R.drawable.cra1_3, false,   50, new InitData(new int[] {3,3,3}, TwistyCrazy3x3.CRAZY  )),
+  CRA2_3 ( TwistyCrazy3x3.class      , 22, R.drawable.cra2_3, false,   80, new InitData(new int[] {3,3,3}, TwistyCrazy3x3.MERCURY)),
+  CRA3_3 ( TwistyCrazy3x3.class      , 22, R.drawable.cra3_3, false,   80, new InitData(new int[] {3,3,3}, TwistyCrazy3x3.VENUS  )),
+  CRA4_3 ( TwistyCrazy3x3.class      , 22, R.drawable.cra4_3, false,   80, new InitData(new int[] {3,3,3}, TwistyCrazy3x3.EARTH  )),
+  CRA5_3 ( TwistyCrazy3x3.class      , 22, R.drawable.cra5_3, false,   80, new InitData(new int[] {3,3,3}, TwistyCrazy3x3.MARS   )),
+  CRA6_3 ( TwistyCrazy3x3.class      , 22, R.drawable.cra6_3, false,   60, new InitData(new int[] {3,3,3}, TwistyCrazy3x3.JUPITER)),
+  CRA7_3 ( TwistyCrazy3x3.class      , 22, R.drawable.cra7_3, false,   80, new InitData(new int[] {3,3,3}, TwistyCrazy3x3.SATURN )),
+  CRA8_3 ( TwistyCrazy3x3.class      , 22, R.drawable.cra8_3, false,   60, new InitData(new int[] {3,3,3}, TwistyCrazy3x3.URANUS )),
+  CRA9_3 ( TwistyCrazy3x3.class      , 22, R.drawable.cra9_3, false,   80, new InitData(new int[] {3,3,3}, TwistyCrazy3x3.NEPTUNE)),
   ;
 
   public static int NUM_OBJECTS;
+  public static final int DEFAULT_PRICE_OF_OLD_OBJECTS = 50;
   public static final int MAX_SCRAMBLES = 42;  // max scrambles at the time we switched from
                                                // remembering the records the old way
   private static final ObjectType[] objects;
@@ -110,7 +111,7 @@ public enum ObjectType
   private final int mNumScrambles;
   private final int mIcon;
   private final boolean mExportToApp;
-  private final boolean mIsFree;
+  private final int mPrice;
   private final Class<? extends TwistyObject> mClass;
 
   static
@@ -125,14 +126,14 @@ public enum ObjectType
 
 ///////////////////////////////////////////////////////////////////////////////////////////////////
 
-  ObjectType(Class<? extends TwistyObject> clazz, int scrambles, int icon, boolean export, boolean isFree, InitData data)
+  ObjectType(Class<? extends TwistyObject> clazz, int scrambles, int icon, boolean export, int price, InitData data)
     {
     mClass       = clazz;
     mInitData    = data;
     mNumScrambles= scrambles;
     mIcon        = icon;
     mExportToApp = export;
-    mIsFree      = isFree;
+    mPrice       = price;
     }
 
 ///////////////////////////////////////////////////////////////////////////////////////////////////
@@ -171,9 +172,9 @@ public enum ObjectType
 
 ///////////////////////////////////////////////////////////////////////////////////////////////////
 
-  public boolean isFree()
+  public int getPrice()
     {
-    return mIsFree;
+    return mPrice;
     }
 
 ///////////////////////////////////////////////////////////////////////////////////////////////////