commit 0310ac32d4f745fdc057f1ff925c6abfcd027413
Author: Leszek Koltunski <leszek@koltunski.pl>
Date:   Thu Sep 30 19:05:17 2021 +0200

    Bugfixes

diff --git a/src/main/java/org/distorted/objectlib/main/Twisty12.java b/src/main/java/org/distorted/objectlib/main/Twisty12.java
index 55edea6e..7c37ec4a 100644
--- a/src/main/java/org/distorted/objectlib/main/Twisty12.java
+++ b/src/main/java/org/distorted/objectlib/main/Twisty12.java
@@ -60,35 +60,35 @@ public abstract class Twisty12 extends TwistyObject
 
 ///////////////////////////////////////////////////////////////////////////////////////////////////
 
-  int getColor(int face)
+  protected int getColor(int face)
     {
     return FACE_COLORS[face];
     }
 
 ///////////////////////////////////////////////////////////////////////////////////////////////////
 
-  int getNumFaceColors()
+  protected int getNumFaceColors()
     {
     return 12;
     }
 
 ///////////////////////////////////////////////////////////////////////////////////////////////////
 
-  int getFOV()
+  protected int getFOV()
     {
     return 30;
     }
 
 ///////////////////////////////////////////////////////////////////////////////////////////////////
 
-  float getScreenRatio()
+  protected float getScreenRatio()
     {
     return 0.35f;
     }
 
 ///////////////////////////////////////////////////////////////////////////////////////////////////
 
-  float returnMultiplier()
+  protected float returnMultiplier()
     {
     return 1.0f;
     }
diff --git a/src/main/java/org/distorted/objectlib/main/Twisty4.java b/src/main/java/org/distorted/objectlib/main/Twisty4.java
index a66f3e1d..2176fa05 100644
--- a/src/main/java/org/distorted/objectlib/main/Twisty4.java
+++ b/src/main/java/org/distorted/objectlib/main/Twisty4.java
@@ -46,35 +46,35 @@ public abstract class Twisty4 extends TwistyObject
 
 ///////////////////////////////////////////////////////////////////////////////////////////////////
 
-  int getColor(int face)
+  protected int getColor(int face)
     {
     return FACE_COLORS[face];
     }
 
 ///////////////////////////////////////////////////////////////////////////////////////////////////
 
-  int getNumFaceColors()
+  protected int getNumFaceColors()
     {
     return 4;
     }
 
 ///////////////////////////////////////////////////////////////////////////////////////////////////
 
-  int getFOV()
+  protected int getFOV()
     {
     return 30;
     }
 
 ///////////////////////////////////////////////////////////////////////////////////////////////////
 
-  float getScreenRatio()
+  protected float getScreenRatio()
     {
     return 0.88f;
     }
 
 ///////////////////////////////////////////////////////////////////////////////////////////////////
 
-  float returnMultiplier()
+  protected float returnMultiplier()
     {
     return getNumLayers()/(SQ6/3);
     }
diff --git a/src/main/java/org/distorted/objectlib/main/Twisty6.java b/src/main/java/org/distorted/objectlib/main/Twisty6.java
index a167f19c..2308a529 100644
--- a/src/main/java/org/distorted/objectlib/main/Twisty6.java
+++ b/src/main/java/org/distorted/objectlib/main/Twisty6.java
@@ -47,35 +47,35 @@ public abstract class Twisty6 extends TwistyObject
 
 ///////////////////////////////////////////////////////////////////////////////////////////////////
 
-  int getColor(int face)
+  protected int getColor(int face)
     {
     return FACE_COLORS[face];
     }
 
 ///////////////////////////////////////////////////////////////////////////////////////////////////
 
-  int getNumFaceColors()
+  protected int getNumFaceColors()
     {
     return 6;
     }
 
 ///////////////////////////////////////////////////////////////////////////////////////////////////
 
-  int getFOV()
+  protected int getFOV()
     {
     return 60;
     }
 
 ///////////////////////////////////////////////////////////////////////////////////////////////////
 
-  float getScreenRatio()
+  protected float getScreenRatio()
     {
     return 0.5f;
     }
 
 ///////////////////////////////////////////////////////////////////////////////////////////////////
 
-  float returnMultiplier()
+  protected float returnMultiplier()
     {
     return getNumLayers();
     }
diff --git a/src/main/java/org/distorted/objectlib/main/Twisty8.java b/src/main/java/org/distorted/objectlib/main/Twisty8.java
index 712c1669..40b0d329 100644
--- a/src/main/java/org/distorted/objectlib/main/Twisty8.java
+++ b/src/main/java/org/distorted/objectlib/main/Twisty8.java
@@ -48,35 +48,35 @@ public abstract class Twisty8 extends TwistyObject
 
 ///////////////////////////////////////////////////////////////////////////////////////////////////
 
-  int getColor(int face)
+  protected int getColor(int face)
     {
     return FACE_COLORS[face];
     }
 
 ///////////////////////////////////////////////////////////////////////////////////////////////////
 
-  int getNumFaceColors()
+  protected int getNumFaceColors()
     {
     return 8;
     }
 
 ///////////////////////////////////////////////////////////////////////////////////////////////////
 
-  int getFOV()
+  protected int getFOV()
     {
     return 60;
     }
 
 ///////////////////////////////////////////////////////////////////////////////////////////////////
 
-  float getScreenRatio()
+  protected float getScreenRatio()
     {
     return 0.65f;
     }
 
 ///////////////////////////////////////////////////////////////////////////////////////////////////
 
-  float returnMultiplier()
+  protected float returnMultiplier()
     {
     return 1.5f;
     }
diff --git a/src/main/java/org/distorted/objectlib/main/TwistyObject.java b/src/main/java/org/distorted/objectlib/main/TwistyObject.java
index 50398aef..5df44b57 100644
--- a/src/main/java/org/distorted/objectlib/main/TwistyObject.java
+++ b/src/main/java/org/distorted/objectlib/main/TwistyObject.java
@@ -757,7 +757,7 @@ public abstract class TwistyObject extends DistortedNode
 
 ///////////////////////////////////////////////////////////////////////////////////////////////////
 
-  int getScrambleType()
+  protected int getScrambleType()
     {
     return 0;
     }
@@ -1285,12 +1285,11 @@ public abstract class TwistyObject extends DistortedNode
 
 ///////////////////////////////////////////////////////////////////////////////////////////////////
 
-  abstract int getFOV();
-  abstract int getNumFaceColors();
-  abstract int getColor(int face);
-  abstract float returnMultiplier();
-  abstract float getScreenRatio();
-
+  protected abstract int getFOV();
+  protected abstract float returnMultiplier();
+  protected abstract float getScreenRatio();
+  protected abstract int getNumFaceColors();
+  protected abstract int getColor(int face);
   protected abstract float[][] getCuts(int numLayers);
   protected abstract int getNumCubitFaces();
   protected abstract Static4D[] getQuats();
diff --git a/src/main/java/org/distorted/objectlib/objects/TwistyMirror.java b/src/main/java/org/distorted/objectlib/objects/TwistyMirror.java
index e304b1d2..8f5b1a4a 100644
--- a/src/main/java/org/distorted/objectlib/objects/TwistyMirror.java
+++ b/src/main/java/org/distorted/objectlib/objects/TwistyMirror.java
@@ -557,7 +557,7 @@ public class TwistyMirror extends Twisty6
 
 ///////////////////////////////////////////////////////////////////////////////////////////////////
 
-  int getColor(int face)
+  protected int getColor(int face)
     {
     return FACE_COLORS[face];
     }
@@ -596,7 +596,7 @@ public class TwistyMirror extends Twisty6
 
 ///////////////////////////////////////////////////////////////////////////////////////////////////
 
-  int getNumFaceColors()
+  protected int getNumFaceColors()
     {
     return 1;
     }
diff --git a/src/main/java/org/distorted/objectlib/objects/TwistySquare1.java b/src/main/java/org/distorted/objectlib/objects/TwistySquare1.java
index 45299528..2a1daf2e 100644
--- a/src/main/java/org/distorted/objectlib/objects/TwistySquare1.java
+++ b/src/main/java/org/distorted/objectlib/objects/TwistySquare1.java
@@ -62,7 +62,7 @@ public class TwistySquare1 extends TwistySquare
 
 ///////////////////////////////////////////////////////////////////////////////////////////////////
 
-  int getScrambleType()
+  protected int getScrambleType()
     {
     return 1;
     }